__kernel void %KERNEL_NAME%(read_only global int *xbuf, read_only global int *ptr, write_only global int *out) {
  int x = get_global_id(0), y = get_global_id(1), p0 = (y << %SHIFT%) + x;
  int g = xbuf[p0];

  if (g != 0) {
    int p = ptr[g] * 2;
    if (xbuf[p0 - 1] == 0) atomic_max(&out[p+0], (1 << %SHIFT%) + (1 << %SHIFT%) - x);
    if (xbuf[p0 + 1] == 0) atomic_max(&out[p+1], x);
  }
}
