__kernel void %KERNEL_NAME%(global int *xbuf, read_only global int *area, global int *out) {
  int x = get_global_id(0), y = get_global_id(1), p0 = (y << %SHIFT%) + x;
  int g = xbuf[p0];

  if (!(g == 0 || g != p0)) {
    if (area[g] >= 30) {
      int p1 = atomic_inc(&out[0]);
      out[p0] = p1;
    } else {
      xbuf[p0] = 0;
    }
  }
}
