__kernel void %KERNEL_NAME%(read_only global int *xbuf, read_only global int *ptr, write_only global int *out) {
  int x = get_global_id(0), y = get_global_id(1), p0 = (y << %SHIFT%) + x;
  int g = xbuf[p0], p = ptr[g] * 16;

  if (g != 0) {
    atomic_max(&out[p+ 0],      x         + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
    atomic_max(&out[p+ 1],      x +     y + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
    atomic_max(&out[p+ 2],              y + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
    atomic_max(&out[p+ 3], -1 * x +     y + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
    atomic_max(&out[p+ 4], -1 * x         + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
    atomic_max(&out[p+ 5], -1 * x - 1 * y + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
    atomic_max(&out[p+ 6],        - 1 * y + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
    atomic_max(&out[p+ 7],      x - 1 * y + 2*((1 << %SHIFT%) + (1 << %SHIFT%)));
  }
}
