__kernel void pass0(__global const unsigned char *srcBuf, __global write_only int *dst,  __global write_only uint *dstBuf) {
  int tidX = get_global_id(0), tidY = get_global_id(1);
  int adr = (tidY * %WIDTH% + tidX)*3;
  int v = (66 * srcBuf[adr+0] + 129 * srcBuf[adr+1] + 25 * srcBuf[adr+2] + 128) >> 8;
  v = v < 0 ? 0 : (v > 255 ? 255 : v);
  dst[(tidY << %SHIFT%) + tidX] = v;

  uint r = srcBuf[adr+0];
  uint g = srcBuf[adr+1];
  uint b = srcBuf[adr+2];

  dstBuf[(tidY << %SHIFT%) + tidX] = r | (g << 8) | (b << 16) | (255 << 24);
}
